(* use"DG-ME-states.sml";
   W.N.24.11.99 
  *)

val seed = ref 2;
fun rand1_1() = (seed:= !seed +1; (!seed mod 2) * ~2 + 1);
(*> rand1_1();rand1_1();rand1_1();rand1_1();rand1_1();rand1_1();
val it = ~1 : int
val it = 1 : int
val it = ~1 : int
val it = 1 : int   TODO !!!*)

type userID = int;
type proofID = int;




(*** imperative proof states ***)

type proofs = (userID * (proofID * ptree) list) list;
val proofs = ref ([]:proofs);
(*
proofs:= [(3,[(31, EmptyPtree), (32, EmptyPtree)]),
	   (4,[(41, EmptyPtree), (42, EmptyPtree)])];
*)
exception PROOFS of string;


(** create new instances of users and ptrees
   new keys are the lowest possible in the association list **)

(* add users *)
fun new_key u n = case assoc (u, n) of 
  None => n 
| Some _ => new_key u (n+1);
fun get_userID (u: proofs) = (new_key u 1):userID;
(*
> val new_userID = get_userID (!proofs);
val it = 1 : int
> proofs:= (!proofs) @ [(new_userID, [])];
> !proofs;
val it = [(3,[(#,#),(#,#)]),(4,[(#,#),(#,#)]),(1,[])]
*)

(* add proofs to a users active proofs *)
fun get_proofID (uI:userID) (p: proofs) = 
  case assoc (p, uI) of 
    None => raise PROOFS ("get_proofID: no userID " ^ 
			  (string_of_int uI))
  | Some ps => (new_key ps 1):proofID;
(*
> get_proofID 1 (!proofs);  
val it = 1 : proofID
*)
fun add_pID (uI:userID) (p: proofs) = 
  let val new_ID = get_proofID uI p;
    val new_pts = (the (assoc (p, uI))) @ [(new_ID,EmptyPtree)];
  in (new_ID, (overwrite (p,(uI,new_pts))):proofs) end;
(*
> val (new_proofID, new_proofs) = add_pID 1 (!proofs);
> proofs:= new_proofs;
> !proofs;
val it = [(3,[(#,#),(#,#)]),(4,[(#,#),(#,#)]),(1,[(#,#)])] : proofs
> val (new_proofID, new_proofs) = add_pID 3 (!proofs);
> proofs:= new_proofs;
> !proofs;
al it = [(3,[(#,#),(#,#),(#,#)]),(4,[(#,#),(#,#)]),(1,[(#,#)])] : proofs
> assoc2 (!proofs, (3, 1));
val it = Some EmptyPtree : ptree option
> assoc2 (!proofs, (3, 2));
val it = None : ptree option
*)


(** retrieve, update, delete a ptree by userID, proofID **)

fun get_prf (uI:userID) (pI:proofID) (p:proofs) = 
  (the (assoc2 (p,(uI, pI)))) 
  handle _ => raise PROOFS ("get_proof " ^ (string_of_int uI) ^
			     " " ^ (string_of_int pI) ^ " not existent");
(*
> get_prf 3 1 (!proofs);
val it = EmptyPtree : ptree
*)
fun get_proof (uI:userID) (pI:proofID) = get_prf uI pI (!proofs);



fun del_assoc ([],_) = []
  | del_assoc a =
  let fun del ([], key) ps = ps
	| del ((keyi, xi) :: pairs, key) ps =
    if key = keyi then ps @ pairs
    else del (pairs, key) (ps @ [(keyi, xi)])
  in del a [] end;
(*
> val ps =  [(1,"1"),(2,"2"),(3,"3"),(4,"4")];     
> del_assoc (ps,3);
val it = [(1,"1"),(2,"2"),(4,"4")] : (int * string) list
*)

(* delete doesn't report non existing elements *)
fun del_assoc2 (uI:userID) (pI:proofID) ps =
  let val new_ps = del_assoc (the (assoc (ps, uI)), pI)
  in overwrite (ps, (uI, new_ps)) end;
(*
> proofs:= del_assoc2 4 41 (!proofs);
> !proofs;
val it = [(3,[(#,#),(#,#),(#,#)]),(4,[(#,#)]),(1,[(#,#)])] : proofs
> proofs:= del_assoc2 4 41 (!proofs);
> !proofs;
val it = [(3,[(#,#),(#,#),(#,#)]),(4,[(#,#)]),(1,[(#,#)])] : proofs

> proofs:= del_user 3 (!proofs);
> !proofs;
val it = [(4,[(#,#)]),(1,[(#,#)])] : proofs
*)

fun overwrite2 (ps, (((uI:userID), (pI:proofID)), p)) = 
  let val new_ps = overwrite (the (assoc (ps, uI)), (pI, p))
  in (overwrite (ps, (uI, new_ps)))
    handle _ => raise PROOFS ("overwrite2 " ^ (string_of_int uI) ^
			      " " ^ (string_of_int pI) ^ " not existent")
  end;
(*
> val (pt,pos) = (EmptyPtree,[]);
> val (pt,_,_) = cappend_problem pt pos "loc" (empty_spec ,[]:cterm' list) [];
> proofs:= upd_ptree 4 42 pt (!proofs);
> get_ptree 4 42 (!proofs);
Nd (PblObj {branch=#,cell=#,env=#,formal=#,...) : ptree
> get_ptree 1 1 (!proofs);
val it = EmptyPtree : ptree
*)
fun upd_proof (uI:userID) (pI:proofID) p = 
  proofs:= overwrite2 ((!proofs), ((uI, pI), p));



(*** imperative dialog states
     they use userID, proofID; + assoc 
     exactly the same way as proofs do
     wrt. userID, proofID; + assoc (dps, cellID) ***)

datatype dtm =
(* in comment the dhpases ..v                       *)
(*<------------------------ 1 --------------------->*)
    PutRes
  | FillRes
(*<--- 2ai ---><--- 2aii --->< ------- 2b --------->*)
  | PutFun
  | SelFun
               | PutArg
               | FillArg
               | SelArg
(*<---------- 2a ---------- >< ------- 2b --------->*)
  | PutRule
  | FillRule
  | SelRule
                             | PutRuleRes
                             | FillRuleRes
  | DtmUndef;

val rule_dtms = [(*PutArg,FillArg,SelArg,*)
		      PutRule(*,FillRule*),SelRule];
val form_dtms = [PutRuleRes(*,FillRuleRes*)];

(* dpstate: for each user, each proof *)
datatype act = 
    Tt           (*Tutor, giving control to St*)
  | TskipS       (*continues recursion in do_dmts*)
  | St           (*student gets the control*)
  | ACundef;

datatype dast = 
    Broken       (*St: breaks datom*)
  | AccepT       (*datom finished by agreement*)
  | ErroR        (*ME reported error in this datom*)
  | NoDtm        (*after resume no continue_pattern, no do_dtm*)
  | FixDtm       (*after resume no continue_pattern, but dtm fixed in resume*)
  | DAundf;

type dct = int;  (*dstep counter: 
		  set into dph in resume_ via init_dct from dstate,
		  decr. in dph in any datom when DPform left;
		  dct in dstate in/decr by SpeedPlus/Minus
		  *)
val default_dct = (1*2-1):dct;
(*(max dphases from St: to St:) * (max dphs per dphase) - (1st dtm)*)


datatype dph = 
    DPdoneR of      (* this datom is already done, finishing DPrule*)
    mstep_ *        (* current rule for DPrule -> DPform*)
                    (* or next_step for DPform -> DPform | DPrule*)
    mout *          (* DPrule -> DPform: form generated by mstep_-check *)
                    (* DPform -> DPform: empty*)
    dct             (* dstep counter: decr at DPform in any datom*)
  | DPdoneF of      (* this datom is already done, finishing DPform*)
    mstep_ *        (* current rule for DPrule -> DPform*)
                    (* or next_step for DPform -> DPform | DPrule*)
    mout *          (* DPrule -> DPform: form generated by mstep_-check *)
                    (* DPform -> DPform: empty*)
    dct             (*dstep counter: decr at DPform in any datom*)
  | DPruleId of     (* 2ai       10.00: NOTYET IMPL.*)
    mstep_ * mstID *(* <- ME, thus applicable            *)
    dct             (*dstep counter*)
  | DPrule of       (* 2aii | 2a *)
    mstep_ *        (* <- ME, thus applicable            *)
    mstep_ *        (* <- user, <>empty <=> <>(<- ME)    *)
    dct             (*dstep counter: decr at DPform in any datom*)
  | DPform of       (* 2b   | 1  *)
    mstep_ *        (* <- ME or user, applicable         *)
    mout * 	    (* <- ME, calculated by mstep_       *)
    foppFK *        (* <- user, <>empty <=> <>mout(<- ME)*)
    dct;            (*dstep counter: decr at DPform in any datom*)
fun dph2str (DPrule (m1,m2,i)) =  
  "DPrule ("^(mstep_2str m1)^
  ","^(mstep_2str m2)^
  ","^(string_of_int i)^")"
  | dph2str (DPform (m,mo,f,i)) = 
  "DPform ("^(mstep_2str m)^
  ","^(mout2str mo)^
  ","^(foppFK2str f)^
  ","^(string_of_int i)^")"
  | dph2str (DPdoneR (m,mo,i)) = 
  "DPdoneR ("^(mstep_2str m)^
  ","^(mout2str mo)^
  ","^(string_of_int i)^")"
  | dph2str (DPdoneF (m,mo,i)) = 
  "DPdoneF ("^(mstep_2str m)^
  ","^(mout2str mo)^
  ","^(string_of_int i)^")";
fun dct_of (DPrule (_,_,dc)) = dc
  | dct_of (DPform (_,_,_,dc)) = dc
  | dct_of (DPdoneR (_,_,dc)) = dc
  | dct_of (DPdoneF (_,_,dc)) = dc;


type acti = int;
(* 6  St PutRes                      ..more active
   5  St FillRes
   4  St SelRule  .. St FillRuleRes | Tt PutRuleRes if speed > 0
   3  St FillRule .. St FillRuleRes | Tt PutRuleRes if speed > 0
   2  St SelRule  .. Tt PutRuleRes  | Tt PutRuleRes if speed > 0
   1  St FillRule .. Tt PutRuleRes  | Tt PutRuleRes if speed > 0
   0  Tt PutRule  .. Tt PutRuleRes   ..less active*)
val default_acti = 4:acti;
type speed = int;
(* 1 TskipS if dct > 0
   0 St | Tt unchanged*)
val default_speed = 1:speed;

(* dstate: for each user *)
type hide = {rules : mstID list, pbls : pblID list, 
	     rlss : rls' list, thms : thmID list};

datatype dstate = 
    EmptyDstate 
  | Dstate of 
    hide *   (*msteps, thms, rls to do tacitly       *)
    acti *   (* = 0: Tt active, < 0: St active in sel_dtm      *)
    speed *  (*decides on 'skip datoms' in sel_dtm             *)
    cellID * (*last cell generated by KE: for newcell*)
    dct;     (*dstep counter as set by init_dct in resume_dpst:
	      dct = dct + (if speed >2 then speed-2 else 0);
              in/decr in resume_  by SpeedPlus/Minus*)
(*18.4.01: speed = dct+1 ...sh fun incr_/decr_speed 
  ... "uberlegen: isac.010418b-dctBEHALTEN 
  + Auto -> speed=3 -- remains in dstate .. ugly, but hard to change*)


val default_hide = 
  {rules = ["Take"             ,"Group",
	    "Split_And"        ,"Conclude_And",
	    "Split_Or"         ,"Conclude_Or",
	    "Begin_Trans"      ,"End_Trans",
	    "Begin_Sequ",
	    "Split_Intersect"  ,"End_Intersect",
	    "Check_elementwise","Collect_Trues",
	    "End_Proof'"], 
   pbls = [["reals","differentiate"]],
   rlss = ["rearrange_assoc"],
   thms = ["add_commute","add_left_commute","add_assoc",
	   "mult_commute","mult_left_commute","mult_assoc"]}:hide;
val test_hide = (*maintaining test_FE-KE.sml*)
  {rules = ["Take"             ,"Group",
	    "Split_And"        ,"Conclude_And",
	    "Split_Or"         ,"Conclude_Or",
	    "Begin_Trans"      ,"End_Trans",
	    "Begin_Sequ",
	    "Split_Intersect"  ,"End_Intersect",
	    "Check_elementwise","Collect_Trues"], 
   pbls = [["reals","differentiate"]],
   rlss = [],
   thms = []}:hide;
val spec_hide = (*hide specification*)
  {rules = specsteps @ ["Apply_Method"], 
   pbls = [], rlss = [], thms = []}:hide;

(*######################################################################*)
(*for demo0*)  val default_hide = spec_hide;                 (*for demo0*)
(*######################################################################*)

val default_dstate = 
    Dstate (default_hide,
	    0,           (*Tt active*)
	    2,           (*PutRuleRes,Tt..PutRule,TskipS..PutRuleRes,Tt..*)
	    0,           (*lowest cellID written by KE*)
	    default_dct);(*maximum dphase count*)
fun d2str EmptyDstate = "EmptyDstate"
  | d2str (Dstate (_, a, s, c, d)) =
  "Dstate (hide..,"^(string_of_int a)^","^
  (string_of_int s)^","^(string_of_int c)^","^(string_of_int d)^")";

fun get_acti EmptyDstate = default_acti
  | get_acti (Dstate (h,a,s,c,d)) = a;
fun set_acti n EmptyDstate = Dstate (default_hide,n,default_speed,0,default_dct)
  | set_acti n (Dstate (h,_,s,c,d)) = Dstate (h, n,s,c,d);

fun get_speed EmptyDstate = default_speed
  | get_speed (Dstate (h,a,s,c,d)) = s:speed;
fun set_speed n EmptyDstate = Dstate (default_hide,default_acti,n,0,default_dct)
  | set_speed n (Dstate (h,a,_,c,d)) = Dstate (h,a, n,c,d);
fun incr_speed EmptyDstate = 
    Dstate (default_hide,default_acti,default_speed,0,default_dct)
  | incr_speed (Dstate (h,a,s,c,d)) = 
    Dstate (h,a,s+1,c,if s+1>2 then s-1 else 1);
fun decr_speed EmptyDstate = 
    Dstate (default_hide,default_acti,0,0,default_dct)
  | decr_speed (Dstate (h,a,s,c,d)) = 
    Dstate (h,a,if s>0 then s-1 else 0,c,if s-1>2 then s-2 else 1);

fun get_dct EmptyDstate = default_dct
  | get_dct (Dstate (h,a,s,c,d)) = d;
fun get_dct' EmptyDstate = default_dct
  | get_dct' (Dstate (_,_,s,_,c)) = if s>2 then s else c;
fun set_dct n EmptyDstate = Dstate (default_hide,default_acti,default_speed,0,n)
  | set_dct n (Dstate (h,a,s,c,_)) = Dstate (h,a,s,c,n);

fun getdecr_cellID EmptyDstate = 
  (Dstate (default_hide,default_acti,default_speed,0,default_dct),~1)
  | getdecr_cellID (Dstate (h,a,s,c,d)) = (Dstate (h,a,s,c-1,d),c-1);

(*init dct in resume_dpst, see in/decr_speed !*)
fun init_dct (Dstate (_,_,s,_,c)) (DPdoneR (r,sf,_))  = DPdoneR  (r,sf,if s>2 then s else c)
  | init_dct (Dstate (_,_,s,_,c)) (DPdoneF (r,sf,_))  = DPdoneF  (r,sf,if s>2 then s else c)
  | init_dct (Dstate (_,_,s,_,c)) (DPform (r,sf,uf,_))= DPform(r,sf,uf,if s>2 then s else c)
  | init_dct (Dstate (_,_,s,_,c)) (DPrule (sr,ur,_))  = DPrule  (sr,ur,if s>2 then s else c)
  | init_dct (Dstate (_,_,s,_,c)) dph = raise error ("dct_of called for "^(dph2str dph));



type dpstate = 
  dtm *               (* PutRule,FillRule,... *)
  act *               (* Tt, St,.. *)
  dast *              (* Broken, AccepT, ErroR,...*)
  (user_cmd option) * (* if this is Some, dast is Broken*)
  dph *               (* contains mstep m, dct*)
  pos';               (* pointing into ptree, where 
		         mstep is applied to | form has been written to*)
val e_dpst = (DtmUndef,Tt,DAundf,None,
	      DPdoneR (e_mstep_,EmptyMout,0),e_pos'):dpstate;


(* the dialog-proof-history; 
   one cellID can address several dpstates, 
   the first dpstate found (beginnin from the heade of dps)
   is taken to the head of dps: this is the _current_ dpstate
   *)
type dps = (cellID * dpstate) list; 

(*for test-writeln*)
fun last_dct (((_,(_,_,_,_,dph,_))::_):dps) = dct_of dph
  | last_dct _ = ~9999;


fun act2str Tt ="Tt"
| act2str TskipS ="TskipS"
| act2str St ="St"
| act2str ACundef ="ACundef";
fun dast2str Broken ="Broken"
| dast2str AccepT ="AccepT"
| dast2str ErroR  ="ErroR"
| dast2str NoDtm = "NoDtm"
| dast2str FixDtm = "FixDtm"
| dast2str DAundf  ="DAundf";
fun dtm2str PutRes   ="PutRes" 
| dtm2str FillRes    ="FillRes" 
| dtm2str PutFun     ="PutFun" 
| dtm2str SelFun     ="SelFun" 
| dtm2str PutArg     ="PutArg" 
| dtm2str FillArg    ="FillArg" 
| dtm2str SelArg     ="SelArg" 
| dtm2str PutRule    ="PutRule" 
| dtm2str FillRule   ="FillRule" 
| dtm2str SelRule    ="SelRule" 
| dtm2str PutRuleRes ="PutRuleRes" 
| dtm2str FillRuleRes="FillRuleRes" 
| dtm2str DtmUndef   ="DtmUndef";
fun cmd2str None = "None"
  | cmd2str (Some c) = "Some "^(user_cmd2str c);
fun dpst2str ((dtm,act,(*dod,*)dast,cmd,dph,pos):dpstate) =
  " ("^(dtm2str dtm)^","^(act2str act)^","^
  (*(dod2str dod)^","^*)(dast2str dast)^","^(cmd2str cmd)^","^
  (dph2str dph)^","^(pos'2str pos)^")";
fun appnl s = s^"\n";
fun dp2str (cellID,dpst) = pair2str(string_of_int cellID,
				    dpst2str dpst);
fun dps2str (dps:dps) = (strs2str' o (map (appnl o dp2str))) (take(11,dps));
(*
> val dps = [(1,e_dpst),(2,e_dpst)]:dps;
> writeln(dps2str dps);
*)



(* use"DG-ME-states.sml";
   *)


type delcells = cellID list;



(* use"DG-ME-states.sml";
   *)


(*select the subsequent datom, 
  acti = 0..6, 
  speed 0..Infinite, speed > 2: skip-count d set by SpeedPlus*)
fun sel_dtm dph (acti:acti) (speed:speed) =
  case dph of
    DPdoneF (r,f,d) =>
    (case (acti, speed) of
       (0,0) => (DPrule (r, e_mstep_, d)      ,  PutRule , Tt    )
     | (0,1) => (DPrule (r, e_mstep_, d)      ,  PutRule , Tt    )
     | (0,2) => (DPrule (r, e_mstep_, d-1)    ,  PutRule , TskipS)(*form halts*)
     | (0,_) => if d<=0 
	   then (DPform (r, f,EmptyFoppFK,d  ),  PutRes  , Tt    )
	   else (DPform (r, f,EmptyFoppFK,d-1),  PutRes  , TskipS)(*18.4.01*)
     | (1,_) => (DPrule (r, e_mstep_, d)      ,  FillRule, St    )
     | (2,_) => (DPrule (r, e_mstep_, d)      ,  SelRule , St    )
     | (3,_) => (DPrule (r, e_mstep_, d)      ,  FillRule, St    )
     | (4,_) => (DPrule (r, e_mstep_, d)      ,  SelRule , St    )
     | (5,_) => (DPform (r, f, EmptyFoppFK, d),  FillRes , St    )
     | (_,_) => (DPform (r, f, EmptyFoppFK, d),  PutRes  , St    )
	       )
  |  DPdoneR (r,f,d) => 
    (case (acti, speed) of
       (0,0) => (DPform (r, f, EmptyFoppFK, d)  ,  PutRuleRes , Tt    )
     | (0,1) => (DPform (r, f, EmptyFoppFK, d-1),  PutRuleRes , TskipS)
     | (0,2) => (DPform (r, f, EmptyFoppFK, d)  ,  PutRuleRes , Tt    )
     | (0,_) => if d<=0 
	   then (DPform (r, f, EmptyFoppFK, d)  ,  PutRuleRes , Tt    )
	   else (DPform (r, f, EmptyFoppFK, d-1),  PutRuleRes , TskipS)
     | (1,0) => (DPform (r, f, EmptyFoppFK, d)  ,  PutRuleRes , Tt    )
     | (1,_) => (DPform (r, f, EmptyFoppFK, d-1),  PutRuleRes , TskipS)
     | (2,0) => (DPform (r, f, EmptyFoppFK, d)  ,  PutRuleRes , Tt    )
     | (2,_) => (DPform (r, f, EmptyFoppFK, d-1),  PutRuleRes , TskipS)
     | (3,0) => (DPform (r, f, EmptyFoppFK, d)  ,  FillRuleRes, St    )
     | (3,_) => (DPform (r, f, EmptyFoppFK, d-1),  PutRuleRes , TskipS)
     | (4,0) => (DPform (r, f, EmptyFoppFK, d)  ,  FillRuleRes, St    )
     | (4,_) => (DPform (r, f, EmptyFoppFK, d-1),  PutRuleRes , TskipS)
     | (5,_) => (DPform (r, f, EmptyFoppFK, d)  ,  FillRuleRes, St    )
     | (_,_) => (DPform (r, f, EmptyFoppFK, d)  ,  PutRuleRes , St    )
	       )
  (*broken*)
  | DPform (r,sf,uf,d) => 
    (case (acti, speed) of
       (0,0) => (DPform (r, sf, uf, d  ), PutRuleRes , Tt    )
     | (0,1) => (DPform (r, sf, uf, d-1), PutRuleRes , TskipS)(*18.4.01*)
     | (0,2) => (DPform (r, sf, uf, d  ), PutRuleRes , Tt    )
     | (0,_) => if d<=0 			   
	   then (DPform (r, sf, uf, d  ), PutRuleRes , Tt    )
	   else (DPform (r, sf, uf, d-1), PutRuleRes , TskipS)(*18.4.01*)
     | (1,0) => (DPform (r, sf, uf, d  ), PutRuleRes , Tt    )
     | (1,_) => (DPform (r, sf, uf, d-1), PutRuleRes , TskipS)(*18.4.01*)
     | (2,0) => (DPform (r, sf, uf, d  ), PutRuleRes , Tt    )
     | (2,_) => (DPform (r, sf, uf, d-1), PutRuleRes , TskipS)(*18.4.01*)
     | (3,0) => (DPform (r, sf, uf, d  ), FillRuleRes, St    )
     | (3,_) => (DPform (r, sf, uf, d-1), PutRuleRes , TskipS)(*18.4.01*)
     | (4,0) => (DPform (r, sf, uf, d  ), FillRuleRes, St    )
     | (4,_) => (DPform (r, sf, uf, d-1), PutRuleRes , TskipS)(*18.4.01*)
     | (5,0) => (DPform (r, sf, uf, d  ), FillRuleRes, St    )
     | (_,_) => (DPform (r, sf, uf, d  ), PutRuleRes , St    )
	       )
  | DPrule (sm,um,d) =>
    (case (acti, speed) of
       (0,0) => (DPrule (sm, um, d)     ,  PutRule   , Tt    )
     | (0,1) => (DPrule (sm, um, d)     ,  PutRule   , Tt    )
     | (0,2) => (DPrule (sm, um, d-1)   ,  PutRule   , TskipS)
     | (0,_) => if d<=0 			   
	   then (DPrule (sm, um, d)     ,  PutRule   , Tt    )
	   else (DPrule (sm, um, d-1)   ,  PutRule   , TskipS)
     | (1,_) => (DPrule (sm, um, d)     ,  FillRule  , St    )
     | (2,_) => (DPrule (sm, um, d)     ,  SelRule   , St    )
     | (3,_) => (DPrule (sm, um, d)     ,  FillRule  , St    )
     | (4,_) => (DPrule (sm, um, d)     ,  SelRule   , St    )
     | (5,_) => (DPrule (sm, um, d-1)   ,  PutRule   , TskipS)
     | (_,_) => (DPrule (sm, um, d-1)   ,  PutRule   , TskipS)
	       )





(* imperative dialog state: association lists only *)
type dials = 
  (userID * dstate) list * (*personal dst (user-model) *)
  (userID * (proofID * cellID list) list) list * (*0..~1..~2..///5.00 *)
  (userID * (proofID * (cellID * dpstate) list) list) list;
                           (*dpstate: info to each cell in a proof*)

val dials = ref (([],[],[]):dials);
exception DIALS of string;
(*
> dials:= ([(3, EmptyDstate), (4, EmptyDstate)],
	   [(3, [(31, [~3101,~3102]), (32, [~3201,~3202])]),
	    (4, [(31, [~3101,~3102]), (32, [~3201,~3202])])],
	    [(3, [(31, [(3101,e_dpst)]), (32, [])]),
	    (4, [(41, []), (42, [])])]);
get_dpst 3 31 3101;
get_dph 3 31 3101;
*)

fun get_dstate (uI:userID) = 
  (the (assoc (fst3 (!dials), uI)))
  handle _ => raise DIALS ("get_dstate " ^ (string_of_int uI) ^
			    " not existent");

(*for maintainance of test-FE-KE.sml: sets hide only*)
fun set_dstate (uI:userID) h acti speed =
    let val (ds,xx,dps) = !dials;
	val Dstate (_,_,_,cell,dct) = (the (assoc (fst3 (!dials), uI)))
	    handle _ => raise DIALS ("get_dstate " ^ (string_of_int uI) ^
				     " not existent");
    in dials:= (overwrite (ds, (uI, Dstate (h,acti,speed,cell,dct))), 
		xx, dps) end;

(*unused after 5.00; keep for other usage*)
fun get_newcells (uI:userID) (pI:proofID) =
  (the (assoc2 (snd3 (!dials), (uI,pI))))
  handle _ => raise DIALS ("get_newcells " ^ (string_of_int uI) ^
			    " not existent");

fun get_dps (uI:userID) (pI:proofID) =
  (the (assoc2 (thd3 (!dials), (uI,pI))))
  handle _ => raise DIALS ("get_dps " ^ (string_of_int uI) ^
			    " not existent");

(*for testing*)
fun get_dpst uI pI cI = the (assoc ((get_dps uI pI), cI));

fun g_dph ((_,_,(*_,*)_,_,dph,_):dpstate) = dph;
fun get_dph uI pI cI = g_dph (get_dpst uI pI cI);

fun g_mstp (DPform ((_,m),_,_,_)) = [m]
  | g_mstp (DPrule ((_,m),_,_)) = [m]
  | g_mstp _ = [];
fun get_msteps uI pI cI = g_mstp (get_dph uI pI cI);

fun g_frm (DPform ((_,_),Form' (FormKF (_,_,_,_,f)),_,_)) = [f]
  | g_frm _ = [];
fun get_forms uI pI cI = g_frm (get_dph uI pI cI);

fun g_ppc (DPform ((_,_),Form' (PpcKF (_,_,_,_,(_,f))),_,_)) = [f]
  | g_ppc _ = [];
fun get_ppcs uI pI cI = g_ppc (get_dph uI pI cI);

fun g_cll (DPform ((_,_),Form' (FormKF (c,_,_,_,_)),_,_)) = [c]
  | g_cll (DPform ((_,_),Form' (PpcKF (c,_,_,_,_)),_,_)) = [c]
  | g_cll _ = [];
fun get_cells uI pI cI = g_cll (get_dph uI pI cI);


fun g_hist ((dtm,act,dast,cmd,_,pos):dpstate) =
    "("^(dtm2str dtm)^", "^(act2str act)^(*", "^(dod2str dod)^*)
    ", "^(dast2str dast)^", "^(cmd2str cmd)^", "^(pos'2str pos)^")";
fun g_pair (c,dpst) = "("^(string_of_int c)^", "^(g_hist dpst)^")\n";
fun get_history uI pI = (strs2str' o (map g_pair)) (get_dps uI pI);
(*for testing*)


fun init_dps (uI:userID) (pI:proofID) (nc:cellID list) (dps:dps) =
    let val (d,_,_) = !dials;
    in dials:= (d,
		overwrite2 (snd3 (!dials), ((uI, pI), nc)),
		overwrite2 (thd3 (!dials), ((uI, pI), dps))) end;
	
(*update imperative dialog-state*)
fun upd_dial (uI:userID) (pI:proofID) 
  (d:dstate) (nc:cellID list) (dps:dps) = 
  dials:= (overwrite (fst3 (!dials), (uI, d)),
	   overwrite2 (snd3 (!dials), ((uI, pI), nc)),
	   overwrite2 (thd3 (!dials), ((uI, pI), dps)));
(*
dials:= ([(3, EmptyDstate), (4, EmptyDstate)],
	 [(3, [(31, [~3101,~3102]), (32, [~3201,~3202])]),
	  (4, [(31, [~3101,~3102]), (32, [~3201,~3202])])],
	 [(3, [(31, [(3101,[e_dpst,e_dpst])]), (32, [])]),
	  (4, [(41, []), (42, []:dps)])]);
> upd_dial 3 33 default_dstate [~1,~2,~3] [(1,[e_dpst])];
> !dials;
  ([(3,Dstate #),(4,EmptyDstate)],[(3,[#,#,#]),(4,[#,#])],
   [(3,[#,#,#]),(4,[#,#])]) : dials

thd3 (!dials);

*)


(** add and delete proofs **)

fun add_proof (uI:userID) = 
  let val (new_proofID, new_proofs) = add_pID uI (!proofs)
  in proofs:= new_proofs; 
    init_dps uI new_proofID [] []; (*30.10.00*)
    new_proofID end; 
fun del_proof (uI:userID) (pI:proofID) = 
  (proofs:= del_assoc2 uI pI (!proofs); 
   dials:= (del_assoc (fst3 (!dials), pI),
	    del_assoc2 uI pI (snd3 (!dials)),
	    del_assoc2 uI pI (thd3 (!dials)));
   pI);


(** add and delete users **)

fun add_user () = 
  let val new_uI = get_userID (!proofs)
  in proofs:= (!proofs) @ [(new_uI, [])];
     dials := ((fst3 (!dials)) @ [(new_uI, default_dstate)],
	       (snd3 (!dials)) @ [(new_uI, [])],
	       (thd3 (!dials)) @ [(new_uI, [])]);
     new_uI end;
(*
> add_user (); add_user (); !proofs; !dials;
*)
(* delete doesn't report non existing elements *)
fun del_user (uI:userID) = 
  (proofs:= del_assoc (!proofs, uI); 
   dials:= (del_assoc (fst3 (!dials), uI),
	    del_assoc (snd3 (!dials), uI),
	    del_assoc (thd3 (!dials), uI));
   uI:userID);


(* -------------- test all exported funs -------------- 

> proofs:=[]; dials:=([],[],[]);
> add_user (); add_user (); !proofs; !dials;
val it = 1 : userID
val it = 2 : userID
val it = [(1,[]),(2,[])] : proofs
val it = ([(1,EmptyDstate),(2,EmptyDstate)],
          [(1,[]),(2,[])],  
	  [(1,[]),(2,[])])
> add_proof 1; add_proof 1; !proofs; !dials; 
val it = 1 : proofID
val it = 2 : proofID
val it = [(1,[(#,#),(#,#)]),(2,[])] : proofs
val it = ([(1,EmptyDstate),(2,EmptyDstate)],
          [(1,[#,#]),(2,[])],
	  [(1,[#,#]),(2,[])])
> val (pt,pos) = (EmptyPtree,[]);
> val (pt,_,_) = cappend_problem pt pos [] (empty_ppc_ct',empty_spec) [];

> upd_proof 1 2 (EmptyScr,pt,[]);
> get_proof 1 1; get_proof 1 2;
val it = (EmptyScr,EmptyPtree,[]) : ptree
val it = (EmptyScr,Nd (PblObj #,[]),[]) : pstate

> upd_dial 1 2 default_dstate [~1,~2] [(1200,[e_dpst])];
> get_dstate 1; 
val it =   Dstate
    {pbls=[[#,#]],rlss=["rearrange_assoc"],
     rules=["Take","Group","Split_And","Conclude_And","Split_Or","Conclude_Or",
            "Begin_Trans","End_Trans",...],
     thms=["add_commute","add_left_commute","add_assoc","mult_commute",
           "mult_left_commute","mult_assoc"]} : dstate

> get_dps 1 1; get_dps 1 2;
val it = [] : (cellID * dpstate list) list
val it = [(1200,[e_dpst])] : (cellID * dpstate list) list
> get_newcells 1 1; get_newcells 1 2;
val it = [] : (cellID * cellID) list
val it = [(~1,1),(~2,2)] : (cellID * cellID) list

> del_proof 2 1; !proofs; !dials;
val it = [(1,[(#,#),(#,#)]),(2,[])] : proofs
val it = ([(2,EmptyDstate)],[(1,[#,#]),(2,[])],[(1,[#,#]),(2,[])]) 

> del_user 1; !proofs; !dials;
val it = [(2,[])] : proofs
val it = ([(2,EmptyDstate)],[(2,[])],[(2,[])]) : dials

> add_user (); add_user (); !proofs; !dials;
val it = 1 : userID
val it = 3 : userID
val it = [(2,[]),(1,[]),(3,[])] : proofs
val it = ([(2,EmptyDstate),(1,EmptyDstate),(3,EmptyDstate)],
          [(2,[]),(1,[]),(3,[])],
	  [(2,[]),(1,[]),(3,[])]) : dials
*)
