(* tests on Atools.thy and Atools.ML
   author: Walther Neuper
   050814, 08:51
   (c) due to copyright terms

use"../smltest/IsacKnowledge/atools.sml";
use"atools.sml";
*)

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- occurs_in -------------------------------------------";
"----------- argument_of -----------------------------------------";
"----------- sameFunId -------------------------------------------";
"-----------------------------------------------------------------";


val thy = Atools.thy;

"----------- occurs_in -------------------------------------------";
"----------- occurs_in -------------------------------------------";
"----------- occurs_in -------------------------------------------";
fun str2t str = (term_of o the o (parse thy )) str;
fun term2s t = Sign.string_of_term (sign_of thy) t;
val t = str2t "x";
if occurs_in t t then "OK" else raise error "atools.sml: occurs_in x x -> f";

val t = str2term "x occurs_in x";
val Some (str, t') = eval_occurs_in 0 "Atools.occurs'_in" t 0;
if (term2s t') = "x occurs_in x = True" then ()
else raise error "atools.sml: x occurs_in x = True ???";

"----------- argument_of -----------------------------------------";
"----------- argument_of -----------------------------------------";
"----------- argument_of -----------------------------------------";
val t = str2t "argument_in (M_b x)";
val Some (str, t') = eval_argument_in 0 "Atools.argument'_in" t 0;
if term2s t' = "(argument_in M_b x) = x" then ()
else raise error "atools.sml:(argument_in M_b x) = x  ???";

"----------- sameFunId -------------------------------------------";
"----------- sameFunId -------------------------------------------";
"----------- sameFunId -------------------------------------------";
val t = str2term "M_b L"; atomty t;
val t as f1 $ _ = str2term "M_b L";
val t as Const ("op =", _) $ (f2 $ _) $ _ = str2term "M_b x = c + L*x";
f1 = f2 (*true*);
val (p as Const ("Atools.sameFunId",_) $ 
			(f1 $ _) $ 
			(Const ("op =", _) $ (f2 $ _) $ _)) = 
    str2term "sameFunId (M_b L) (M_b x = c + L*x)";
f1 = f2 (*true*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2term "sameFunId (M_b L) (M_b x = c + L*x)")""(*true*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2term "sameFunId (M_b L) ( y' x = c + L*x)")""(*false*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2term "sameFunId (M_b L) (  y x = c + L*x)")""(*false*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2term "sameFunId (  y L) (M_b x = c + L*x)")""(*false*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2term "sameFunId (  y L) (  y x = c + L*x)")""(*true*);

(* use"IsacKnowledge/Atools.ML";
   use"../smltest/IsacKnowledge/atools.sml";
   *)