(* tests on biegelinie
   author: Walther Neuper 050826
   (c) due to copyright terms

use"../smltest/IsacKnowledge/biegelinie.sml";
use"biegelinie.sml";
*)
val thy = Biegelinie.thy;

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- the rules -------------------------------------------";
"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- simplify_leaf for this script -----------------------";
"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----------- IntegrierenUndKonstanteBestimmen2 -------------------";
"----------- investigate normalforms -----------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"----------- the rules -------------------------------------------";
"----------- the rules -------------------------------------------";
"----------- the rules -------------------------------------------";
fun str2t str = (term_of o the o (parse Biegelinie.thy)) str;
fun term2s t = Sign.string_of_term (sign_of Biegelinie.thy) t;
fun rewrit thm str = 
    fst (the (rewrite_ Biegelinie.thy tless_true e_rls true thm str));

val t = rewrit Belastung_Querkraft (str2t "- q x = - q_0"); term2s t;
if term2s t = "Q' x = - q_0" then ()
else raise error  "/biegelinie.sml: Belastung_Querkraft";

val t = rewrit Querkraft_Moment (str2t "Q x = - q_0 * x + c"); term2s t;
if term2s t = "M_b' x = - q_0 * x + c" then ()
else raise error  "/biegelinie.sml: Querkraft_Moment";

val t = rewrit Moment_Neigung (str2t "M_b x = -q_0 * x^^^2/2 + q_0/2 *L*x");
    term2s t;
if term2s t = "- EI * y'' x = - q_0 * x ^^^ 2 / 2 + q_0 / 2 * L * x" then ()
else raise error  "biegelinie.sml: Moment_Neigung";


"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
val str =
"Script BiegelinieScript                                                  \
\(l_::real) (q_::real) (v_::real) (b_::real=>real)                        \
\(rb_::bool list) (rm_::bool list) =                                      \
\  (let q__ = Take (q v_ = q_);                                           \
\       q__ = ((Rewrite sym_real_minus_eq_cancel True) @@                 \
\              (Rewrite Belastung_Querkraft True)) q__;                   \
\      (Q__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs q__), real_ v_, real_real_ Q]);    \
\       Q__ = Rewrite Querkraft_Moment True Q__;                          \
\      (M__::bool) =                                                      \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs Q__), real_ v_, real_real_ M_b]);  \
\       e1__ = nth_ 1 rm_;                                                \
\      (x1__::real) = argument_in (lhs e1__);                             \
\      (M1__::bool) = (Substitute [v_ = x1__]) M__;                       \
\       M1__        = (Substitute [e1__]) M1__ ;                          \
\       M2__ = Take M__;                                                  "^
(*without this Take 'Substitute [v_ = x2__]' takes _last formula from ctree_*)
"       e2__ = nth_ 2 rm_;                                                \
\      (x2__::real) = argument_in (lhs e2__);                             \
\      (M2__::bool) = ((Substitute [v_ = x2__]) @@                        \
\                      (Substitute [e2__])) M2__;                         \
\      (c_1_2__::bool list) =                                             \
\             (SubProblem (Biegelinie_,[linear,system],[no_met])          \
\                          [booll_ [M1__, M2__], reall [c,c_2]]);         \
\       M__ = Take  M__;                                                  \
\       M__ = ((Substitute c_1_2__) @@                                    \
\              (Try (Rewrite_Set_Inst [(bdv_1, c),(bdv_2, c_2)]\
\                                   simplify_System False)) @@ \
\              (Rewrite Moment_Neigung False) @@ \
\              (Rewrite make_fun_explicit False)) M__;                    "^
(*----------------------- and the same once more ------------------------*)
"      (N__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs M__), real_ v_, real_real_ y']);   \
\      (B__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs N__), real_ v_, real_real_ y]);    \
\       e1__ = nth_ 1 rb_;                                                \
\      (x1__::real) = argument_in (lhs e1__);                             \
\      (B1__::bool) = (Substitute [v_ = x1__]) B__;                       \
\       B1__        = (Substitute [e1__]) B1__ ;                          \
\       B2__ = Take B__;                                                  \
\       e2__ = nth_ 2 rb_;                                                \
\      (x2__::real) = argument_in (lhs e2__);                             \
\      (B2__::bool) = ((Substitute [v_ = x2__]) @@                        \
\                      (Substitute [e2__])) B2__;                         \
\      (c_1_2__::bool list) =                                             \
\             (SubProblem (Biegelinie_,[linear,system],[no_met])          \
\                          [booll_ [B1__, B2__], reall [c,c_2]]);         \
\       B__ = Take  B__;                                                  \
\       B__ = ((Substitute c_1_2__) @@                                    \
\              (Rewrite_Set_Inst [(bdv, x)] make_ratpoly_in False)) B__   \
\ in B__)"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---^^^-OK-----------------------------------------------------------------*)
(*---vvv-NOTok--------------------------------------------------------------*)
atomty sc;
atomt sc;

(* use"../smltest/IsacKnowledge/biegelinie.sml";
   *)

"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
val t = str2t "M_b x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2";
val t = rewrit Moment_Neigung t; term2s t;
(*was "EI * ?y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2"
           ### before declaring "y''" as a constant *)
val t = rewrit make_fun_explicit t; term2s t;


"----------- simplify_leaf for this script -----------------------";
"----------- simplify_leaf for this script -----------------------";
"----------- simplify_leaf for this script -----------------------";
val rm_ = str2term"[M_b 0 = 0, M_b L = 0]";
val M__ = str2term"M_b x = -1 * x ^^^ 2 / 2 + x * c + c_2";
val Some (e1__,_) = 
    rewrite_set_ thy false srls 
		 (str2term"(nth_::[real,bool list]=>bool) 1 " $ rm_);
if term2str e1__ = "M_b 0 = 0" then ()
else raise error "biegelinie.sml simplify nth_ 1 rm_";

val Some (x1__,_) = 
    rewrite_set_ thy false srls 
		 (str2term"argument_in (lhs (M_b 0 = 0))");
if term2str x1__ = "0" then ()
else raise error "biegelinie.sml simplify argument_in (lhs (M_b 0 = 0)";

trace_rewrite:=true;
trace_rewrite:=false;



"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 me -----------------------------------------";
val fmz = ["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	   "RandbedingungenBiegung [y 0 = 0, y L = 0]",
	   "RandbedingungenMoment [M_b 0 = 0, M_b L = 0]",
	   "FunktionsVariable x"];
val (dI',pI',mI') =
  ("Biegelinie.thy",["MomentBestimmte","Biegelinien"],
   ["IntegrierenUndKonstanteBestimmen"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;

val pits = get_obj g_pbl pt (fst p);writeln (itms2str thy pits);
(*if itms2str thy pits = ... all 5 model-items*)
val mits = get_obj g_met pt (fst p); writeln (itms2str thy mits);
if itms2str thy mits = "[]" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #2";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_,Add_Given "FunktionsVariable x") => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4a";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val mits = get_obj g_met pt (fst p);writeln (itms2str thy mits);
(*if itms2str thy mits = ... all 6 guard-items*)
case nxt of (_, Apply_Method ["IntegrierenUndKonstanteBestimmen"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4b";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case pt of Nd (PblObj _, [Nd _]) => ((*Apply_Method + Take*))
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4c";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

case nxt of 
    (_,Subproblem ("Biegelinie.thy", ["named", "integrate", "function"])) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4c";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration", "named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #5";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of 
    ("Check_Postcond", Check_Postcond ["named", "integrate", "function"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #5a";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of 
    (_, Subproblem ("Biegelinie.thy", ["named", "integrate", "function"]))=>()
  | _ => raise error "biegelinie.sml: Bsp 7.27 #5b";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration","named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #6";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt(*nxt = Check_Postcond ["named", "int..*);
f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Substitute ["x = 0"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #7";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "0 = c_2 + c * 0 + -1 * q_0 / 2 * 0 ^^^ 2" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #8";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #9";

(*val nxt = (+, Subproblem ("Biegelinie.thy", ["normalize", ..lin..sys]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["EqSystem", "normalize", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #10";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
(*val nxt = Subproblem ["triangular", "2x2", "linear", "system"]*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["EqSystem", "top_down_substitution", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #11";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Check_Postcond ["normalize", "2x2", "linear", "system"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #12";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Subproblem ("Biegelinie.thy", ["named", "integrate", "function"]))=>()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #13";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration", "named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #14";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Check_Postcond ["named", "integrate", "function"]) => ()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #15";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f =
  "y' x = c + 1 / (-1 * EI) * (L * q_0 / 4 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)"
then () else raise error  "biegelinie.sml: Bsp 7.27 #16 f";
case nxt of
    (_, Subproblem ("Biegelinie.thy", ["named", "integrate", "function"]))=>()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #16";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration", "named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #17";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = 
   "y x =\nc_2 + c * x +\n\
   \1 / (-1 * EI) * (L * q_0 / 12 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)"
then () else raise error  "biegelinie.sml: Bsp 7.27 #18 f";
case nxt of
    (_, Check_Postcond ["named", "integrate", "function"]) => ()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #18";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Subproblem
            ("Biegelinie.thy", ["normalize", "2x2", "linear", "system"])) => ()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #19";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["EqSystem", "normalize", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #20";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "[c_2 = 0, L * c + c_2 = -1 * q_0 * L ^^^ 4 / (-24 * EI)]" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #21 f";
case nxt of
    (_, Subproblem
            ("Biegelinie.thy", ["triangular", "2x2", "linear", "system"])) =>()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #21";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["EqSystem", "top_down_substitution", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #22";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Check_Postcond ["normalize", "2x2", "linear", "system"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #23";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "y x =\n-1 * q_0 * L ^^^ 4 / (-24 * EI * L) * x +\n\
	     \(2 * L * q_0 / (-24 * EI) * x ^^^ 3 + \
	     \-1 * q_0 / (-24 * EI) * x ^^^ 4)" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #24 f";
case nxt of ("End_Proof'", End_Proof') => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #24";

(* use"../smltest/IsacKnowledge/biegelinie.sml";
   *)
show_pt pt;
(*(([], Frm), Problem (Biegelinie.thy, [MomentBestimmte, Biegelinien])),
(([1], Frm), q x = q_0),
(([1], Res), - q x = - q_0),
(([2], Res), Q' x = - q_0),
(([3], Pbl), Integrate (- q_0, x)),
(([3,1], Frm), Q x = Integral - q_0 D x),
(([3,1], Res), Q x = -1 * q_0 * x + c),
(([3], Res), Q x = -1 * q_0 * x + c),
(([4], Res), M_b' x = -1 * q_0 * x + c),
(([5], Pbl), Integrate (-1 * q_0 * x + c, x)),
(([5,1], Frm), M_b x = Integral -1 * q_0 * x + c D x),
(([5,1], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2),
(([5], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2),
(([6], Res), M_b 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2),
(([7], Res), 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2),
(([8], Res), M_b L = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2),
(([9], Res), 0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2),
(([10], Pbl), solveSystem [0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2] [c_2]),
(([10,1], Frm), [0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2,
 0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2]),
(([10,1], Res), [0 = c_2, 0 = -1 * (q_0 * L ^^^ 2) / 2 + (L * c + c_2)]),
(([10,2], Res), [c_2 = 0, L * c + c_2 = 0 + -1 * (-1 * (q_0 * L ^^^ 2) / 2)]),
(([10,3], Res), [c_2 = 0, L * c + c_2 = q_0 * L ^^^ 2 / 2]),
(([10,4], Pbl), solveSystem [L * c + c_2 = q_0 * L ^^^ 2 / 2] [c_2]),
(([10,4,1], Frm), L * c + c_2 = q_0 * L ^^^ 2 / 2),
(([10,4,1], Res), L * c + 0 = q_0 * L ^^^ 2 / 2),
(([10,4,2], Res), L * c = q_0 * L ^^^ 2 / 2),
(([10,4,3], Res), c = q_0 * L ^^^ 2 / 2 / L),
(([10,4,4], Res), c = L * q_0 / 2),
(([10,4,5], Res), [c = L * q_0 / 2, c_2 = 0]),
(([10,4], Res), [c = L * q_0 / 2, c_2 = 0]),
(([10], Res), [c = L * q_0 / 2, c_2 = 0]),
(([11], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * (L * q_0 / 2) + 0),
(([12], Res), M_b x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2),
(([13], Res), EI * y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2),
(([14], Res), y'' x = 1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2)),
(([15], Pbl), Integrate (1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2), x)),
(([15,1], Frm), y' x = Integral 1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2) D x),
(([15,1], Res), y' x =
(Integral L * q_0 * x / 2 D x + Integral -1 * q_0 * x ^^^ 2 / 2 D x) / EI +
c)]*)

"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
 states:=[];
 CalcTree [(["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	     "RandbedingungenBiegung [y 0 = 0, y L = 0]",
	     "RandbedingungenMoment [M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x"],
	    ("Biegelinie.thy",
	     ["MomentBestimmte","Biegelinien"],
	     ["IntegrierenUndKonstanteBestimmen"]))];
 moveActiveRoot 1;
 autoCalculate 1 CompleteCalcHead; 

 fetchProposedTactic 1 (*->"Apply_Method" IntegrierenUndKonstanteBestimmen*);
(*
> val (_,Apply_Method' (_, None, ScrState is), _)::_ = tacis;
> is = e_scrstate;
val it = true : bool
*)
 autoCalculate 1 (Step 1) (*->GENERATED ([1], Frm)*);
 val ((pt,_),_) = get_calc 1;
 case pt of Nd (PblObj _, [Nd _]) => ((*Apply_Method + Take*))
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 autoCalculate#4c";

 autoCalculate 1 CompleteCalc;  
 val (unc, del, gen) = (([],Pbl), ([],Pbl), ([],Res));
 getFormulaeFromTo 1 unc gen 1 (*only level 1*) false;

 val ((pt,_),_) = get_calc 1;
 show_pt pt;

(*check all formulae for getTactic*)
 getTactic 1 ([1],Frm) (*see smltest/../reverse-rew.sml*);
 getTactic 1 ([5],Res) (*tac2xml: not impl. for Substitute ["x = 0"]*);
 getTactic 1 ([6],Res) (* ---"---                      ["M_b 0 = 0"]*);
 getTactic 1 ([7],Res) (*!!!!!Take!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*);
 getTactic 1 ([8],Frm) (*tac2xml: not impl. for Substitute ["x = L"]*);
 getTactic 1 ([8],Res) (* ---"---                      ["M_b L = 0"]*);


"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
val str =
"Script Function2Equality (fun_::bool) (sub_::bool) =\
\(equ___::bool)"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
val str =
"Script Function2Equality (fun_::bool) (sub_::bool) =\
\ (let v_ = argument_in (lhs fun_)\
\ in (equ___::bool))"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
val str =
"Script Function2Equality (fun_::bool) (sub_::bool) =\
\ (let v_ = argument_in (lhs fun_);\
\     (equ_) = (Substitute [sub_]) fun_\
\ in (equ_::bool))"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
val str =
"Script Function2Equality (fun_::bool) (sub_::bool) =\
\ (let v_ = argument_in (lhs fun_);\
\      equ_ = (Substitute [sub_]) fun_\
\ in (Rewrite_Set_Inst [(bdv, v_)] make_ratpoly_in False) equ_)"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---^^^-OK-----------------------------------------------------------------*)
val str =
(*(M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) (M_b L = 0) -->
       0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2*)
"Script Function2Equality (fun_::bool) (sub_::bool) =\
\ (let bdv_ = argument_in (lhs fun_);\
\      val_ = argument_in (lhs sub_);\
\      equ_ = (Substitute [bdv_ = val_]) fun_;\
\      equ_ = (Substitute [sub_]) fun_\
\ in (Rewrite_Set_Inst [(bdv_, v_)] make_ratpoly_in False) equ_)"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---vvv-NOTok--------------------------------------------------------------*)
atomty sc;

val fmz = ["functionEq (M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2)", 
	   "substitution (M_b L = 0)", 
	   "equality equ___"];
val (dI',pI',mI') = ("Biegelinie.thy", ["makeFunctionTo","equation"],
		     ["Equation","fromFunction"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
			"M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
                        "M_b L = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
			"0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if nxt = ("End_Proof'", End_Proof') andalso
(*   f2str f = "0 = c_2 + L * c + -1 * q_0 / 2 * L ^^^ 2"
CHANGE NOT considered, already on leave*)
   f2str f = "0 = (2 * c_2 + 2 * L * c + -1 * L ^^^ 2 * q_0) / 2"
then () else raise error "biegelinie.sml: SubProblem (_,[setzeRandbed";


"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----- check the scripts syntax";
val str =
"Script SetzeRandbedScript (funs_::bool list) (beds_::bool list) =\
\ (let b1 = Take (nth_ 1 beds_)\
\ in (equs_::bool list))"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
val str =
"Script SetzeRandbedScript (funs_::bool list) (beds_::bool list) =\
\ (let b1_ = Take (nth_ 1 beds_);   \
\      fs_ = filter (sameFunId (lhs b1_)) funs_;  \
\      f1_ = hd fs_             \
\ in (equs_::bool list))"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;

val ttt = str2term "sameFunId (lhs b1_) fun___"; atomty ttt;
val ttt = str2term "filter"; atomty ttt;
val ttt = str2term "filter::[real => bool, real list] => real list";atomty ttt;
val ttt = str2term "filter::[bool => bool, bool list] => bool list";
val ttt = str2term "filter (sameFunId (lhs b1_)) funs_"; atomty ttt;

val str =
"Script SetzeRandbedScript (funs_::bool list) (rb_::bool list) =\
\ (let beds_ = rev beds_;                                       \
\      b1_ = Take (nth_ 1 beds_);                               \
\      fs_ = filter (sameFunId (lhs b1_)) funs_;              \
\      f1_ = hd fs_                                           \
\ in (equs_::bool list))"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
val str =
"Script SetzeRandbedScript (funs_::bool list) (rb_::bool list) =\
\ (let b1_ = Take (nth_ 1 rb_);                               \
\      fs_ = filter (sameFunId (lhs b1_)) funs_;                \
\      (equ_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b1_])                    \
\ in [equ_])"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
val str =
"Script SetzeRandbedScript (funs_::bool list) (rb_::bool list) =\
\ (let b1_ = Take (nth_ 1 rb_);                               \
\      fs_ = filter (sameFunId (lhs b1_)) funs_;                \
\      (e1_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b1_]);                    \
\      b2_ = Take (nth_ 2 rb_);                               \
\      fs_ = filter (sameFunId (lhs b2_)) funs_;                \
\      (e2_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b2_])                    \
\ in [e1_,e1_])"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---vvv-NOTok--------------------------------------------------------------*)
val str =
"Script SetzeRandbedScript (funs_::bool list) (rb_::bool list) =\
\ (let b1_ = Take (nth_ 1 rb_);                               \
\      fs_ = filter (sameFunId (lhs b1_)) funs_;                \
\      (e1_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b1_]);                    \
\      b2_ = Take (nth_ 2 rb_);                               \
\      fs_ = filter (sameFunId (lhs b2_)) funs_;                \
\      (e2_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b2_])                    \
\      b3_ = Take (nth_ 3 rb_);                               \
\      fs_ = filter (sameFunId (lhs b3_)) funs_;                \
\      (e3_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b3_])                    \
\      b4_ = Take (nth_ 4 rb_);                               \
\      fs_ = filter (sameFunId (lhs b4_)) funs_;                \
\      (e4_::bool) =                                               \
\             (SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b4_])                    \
\ in [e1_,e2_,e3_,e4_])"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---^^^-OK-----------------------------------------------------------------*)
atomty sc;

"----- execute script by manual rewriting";
(*show_types := true;*)
val funs_ = str2term "funs_::bool list";
val funs = str2term
    "[Q x = c + -1 * q_0 * x,\
    \M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\
    \y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\
    \y x = c_4 + c_3 * x + 1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]";
val rb_ = str2term "rb_::bool list";
val rb = str2term "[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]";

"--- script expression 1";
val screxp1_ = str2term "Take (nth_ 1 (rb_::bool list))";
val screxp1  = subst_atomic [(rb_, rb)] screxp1_; term2str screxp1;
val Some (b1,_) = rewrite_set_ Isac.thy false srls2 screxp1; term2str b1;
if term2str b1 = "Take (y 0 = 0)" then ()
else raise error "biegelinie.sml: rew. Bieglie2 --1";
val b1 = str2term "(y 0 = 0)";

"--- script expression 2";
val screxp2_ = str2term "filter (sameFunId (lhs b1_)) funs_";
val b1_ = str2term "b1_::bool";
val screxp2 = subst_atomic [(b1_,b1),(funs_,funs)] screxp2_; term2str screxp2;
val Some (fs,_) = rewrite_set_ Isac.thy false srls2 screxp2; term2str fs;
if term2str fs =  "[y x =\n c_4 + c_3 * x +\n 1 / (-1 * EI) *\n (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]" then ()
else raise error "biegelinie.sml: rew. Bieglie2 --2";

"--- script expression 3";
val screxp3_ = str2term "SubProblem (Biegelinie_,[makeFunctionTo,equation],\
\                          [Equation,fromFunction])         \
\                          [bool_ (hd fs_), bool_ b1_]";
val fs_ = str2term "fs_::bool list";
val screxp3 = subst_atomic [(fs_,fs),(b1_,b1)] screxp3_; 
writeln (term2str screxp3);
val Some (equ,_) = rewrite_set_ Isac.thy false srls2 screxp3; 
if term2str equ = "SubProblem\n (Biegelinie_, [makeFunctionTo, equation], [Equation, fromFunction])\n [bool_\n   (y x =\n    c_4 + c_3 * x +\n    1 / (-1 * EI) *\n    (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)),\n  bool_ (y 0 = 0)]" then ()
else raise error "biegelinie.sml: rew. Bieglie2 --3";
writeln (term2str equ);
(*SubProblem
 (Biegelinie_, [makeFunctionTo, equation], [Equation, fromFunction])
 [bool_
   (y x =
    c_4 + c_3 * x +
    1 / (-1 * EI) *
    (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)),
  bool_ (y 0 = 0)]*)
show_types := false;


"----- execute script by interpreter";
val fmz = ["Funktionen [Q x = c + -1 * q_0 * x,\
    \M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\
    \y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\
    \y x = c_4 + c_3 * x + 1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]",
	   "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]",
	   "Gleichungen equs___"];
val (dI',pI',mI') = ("Biegelinie.thy", ["setzeRandbedingungen","Biegelinien"],
		     ["Biegelinien","setzeRandbedingungenEin"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "y 0 = 0";
(*WN060902??? missing Substitute ???*)
case nxt of (_,Subproblem (_, ["makeFunctionTo", "equation"])) => ()
| _ => raise error "biegelinie.sml: met setzeRandbed*Ein 1";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "y 0 =\nc_4 + c_3 * 0 +\n1 / (-1 * EI) *\n(c_2 / 2 * 0 ^^^ 2 + c / 6 * 0 ^^^ 3 + -1 * q_0 / 24 * 0 ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "0 =\nc_4 + c_3 * 0 +\n1 / (-1 * EI) *\n(c_2 / 2 * 0 ^^^ 2 + c / 6 * 0 ^^^ 3 + -1 * q_0 / 24 * 0 ^^^ 4)"
;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_4 + 0 / (-1 * EI)";
(*WN060902 thm real_0_divide in rls reduce_0_1_2 in rls norm_Rational^^^notap*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_4 + 0 / (-1 * EI)";
(*end of 1st "Randbedingung einsetzen"*)

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "y L = 0";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*WN060902 strange msgs also here !!!! GOON*)


(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*)
(*
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
*)

"----------- IntegrierenUndKonstanteBestimmen2 -------------------";
"----------- IntegrierenUndKonstanteBestimmen2 -------------------";
"----------- IntegrierenUndKonstanteBestimmen2 -------------------";
"----- script ";
val str = 
"Script Belastung2BiegelScript (q_::real) (v_::real) =                    \
\  (let q__ = Take (q v_ = q_);                                           \
\       q__ = ((Rewrite sym_real_minus_eq_cancel True) @@                 \
\              (Rewrite Belastung_Querkraft True)) q__;                   \
\      (Q__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs q__), real_ v_, real_real_ Q]);    \
\       M__ = Rewrite Querkraft_Moment True Q__;                          \
\      (M__::bool) =                                                      \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs M__), real_ v_, real_real_ M_b]);  \
\       N__ = ((Rewrite Moment_Neigung False) @@                          \
\              (Rewrite make_fun_explicit False)) M__;                    \
\      (N__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs N__), real_ v_, real_real_ y']);   \
\      (B__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs N__), real_ v_, real_real_ y])    \
\ in [Q__, M__, N__, B__])"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---^^^-OK-----------------------------------------------------------------*)
(*---vvv-NOTok--------------------------------------------------------------*)


"----- met [Biegelinien,ausBelastung]";
val fmz = ["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	     "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x"];
val (dI',pI',mI') = ("Biegelinie.thy", ["Biegelinien"],
		     ["IntegrierenUndKonstanteBestimmen2"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
if nxt = ("Apply_Method", Apply_Method ["IntegrierenUndKonstanteBestimmen2"])
then () else raise error "biegelinie.sml met2 a";

(*** actual arg(s) missing for '["(#Find, (Funktionen, funs_))"]' i.e. should be 'copy-named' by '*_._'
... THIS MEANS: 
#a# "Script Biegelinie2Script ..
\         ... (SubProblem (Biegelinie_,[vonBelastungZu,Biegelinien],      \
\                          [Biegelinien,ausBelastung])                    \
\                          [real_ q_, real_ v_]);                         \

#b# prep_met ... (["Biegelinien","ausBelastung"],
              ... ("#Given" ,["Streckenlast q_","FunktionsVariable v_"]),
   "Script Belastung2BiegelScript (q_::real) (v_::real) =                 \

#a#b# BOTH HAVE 2 ARGUMENTS q_ and v_ ...OK
##########################################################################
BUT THE (#Find, (Funktionen, funs_)) IS NOT COPYNAMED BY funs___ !!!3*_!!!
##########################################################################*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
if nxt = ("Apply_Method", Apply_Method ["Biegelinien", "ausBelastung"])
then () else raise error "biegelinie.sml met2 b";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =   "q x = q_0";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "- q x = - q_0";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =  "Q' x = - q_0";
case nxt of (_, Subproblem (_, ["named", "integrate", "function"])) => ()
| _ => raise error "biegelinie.sml met2 c";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "Q x = c + -1 * q_0 * x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "Q x = c + -1 * q_0 * x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "M_b' x = c + -1 * q_0 * x";
case nxt of (_,Subproblem (_, ["named", "integrate", "function"])) => ()
| _ => raise error "biegelinie.sml met2 d";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
		   "M_b x = Integral c + -1 * q_0 * x D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
		   "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "- EI * y'' x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "y'' x = 1 / - EI * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2)";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
    "y' x = Integral 1 / - EI * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x = Integral 1 / (-1 * EI) * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x =\nc_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x =\nc_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y x =\nIntegral c_3 +\n         1 / (-1 * EI) *\n         (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "[Q x = c + -1 * q_0 * x,\n y x =\n c_4 + c_3 * x +\n 1 / (-1 * EI) *\n (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4),\n y' x =\n c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\n y x =\n c_4 + c_3 * x +\n 1 / (-1 * EI) *\n (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]";
case nxt of (_,Subproblem (_, ["setzeRandbedingungen", "Biegelinien"])) => ()
| _ => raise error "biegelinie.sml met2 d";
 
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Biegelinien", "setzeRandbedingungenEin"]) => ()
| _ => raise error "biegelinie.sml met2 e";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "y 0 = 0";
(*WN060902 is the ctree ok here?: Take -> SubProblem !*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Equation", "fromFunction"]) => ()
| _ => raise error "biegelinie.sml met2 f";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_4 + 0 / (-1 * EI)";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "y L = 0";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*WN060902 strange msgs *** upd_env_opt: (None,SubProblem (Biegelinie_, [m..*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Equation", "fromFunction"]) => ()
| _ => raise error "biegelinie.sml met2 g";

(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2*)

val (p,_,f,nxt,_,pt) = me nxt p c pt;
nxt = ("Empty_Tac", Empty_Tac) (*true*);


(*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@2*)
(*
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
*)


"----------- investigate normalforms -----------------------------";
"----------- investigate normalforms -----------------------------";
"----------- investigate normalforms -----------------------------";
"----- coming from integration:";
val Q = str2term "Q x = c + -1 * q_0 * x";
val M_b = str2term "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val y' = str2term "y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val y = str2term "y x = c_4 + c_3 * x +\n1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
(*^^^  1 / (-1 * EI) NOT distributed - ok! ^^^^^^^^^^^^^^^^^^^^^^^*)

"----- functions comming from:";
