(* test for sml/ME/rewtools.sml
   authors: Walther Neuper 2000, 2006
   (c) due to copyright terms

use"../smltest/ME/rewtools.sml";
use"rewtools.sml";
*)

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- fun collect_isab_thys -------------------------------";
"----------- fun thy_containing_thm ------------------------------";
"----------- fun thy_containing_rls ------------------------------";
"----------- fun thy_containing_cal ------------------------------";
"----------- initContext Thy_ Integration-demo -------------------";
"----------- initContext..Thy_, fun context_thm ------------------";
"----------- initContext..Thy_, fun context_rls ------------------";
"----------- checkContext..Thy_, fun context_thy -----------------";
"----------- checkContext..Thy_, fun context_rls -----------------";
"----------- checkContext..Thy_ on last formula ------------------"; 
"----------- fun guh2theID ---------------------------------------";
"----------- debugging on Tests/solve_linear_as_rootpbl ----------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";



"----------- fun collect_isab_thys -------------------------------";
"----------- fun collect_isab_thys -------------------------------";
"----------- fun collect_isab_thys -------------------------------";
val thy = first_isac_thy (*def. in Script/ListG.ML*); 
val {ancestors,...} = rep_theory thy;
print_depth 99; map string_of_thy ancestors; print_depth 3;
length ancestors;
val ancestors = (#ancestors o rep_theory) first_isac_thy;
length ancestors;
print_depth 99; map theory2theory' ancestors; print_depth 3;
val isabthms = (flat o (map thms_of)) ancestors;
length isabthms;

val isacrules = (flat o (map (thms_of_rls o #2 o #2))) (!ruleset');
(*thms from rulesets*)
val isacrlsthms = ((map rep_thm_G') o flat o 
		(map (thms_of_rls o #2 o #2))) (!ruleset');
length isacrlsthms;
(*takes a few seconds...
val isacrlsthms = gen_distinct eq_thmI isacrlsthms;
length isacrlsthms;
"----- theorems used in isac's rulesets -----vvvvvvvvvvvvvvvvvvvvv";
print_depth 99; map #1 isacrlsthms; print_depth 3;
"----- theorems used in isac's rulesets -----^^^^^^^^^^^^^^^^^^^^^";
...*)

(!theory');
map #2 (!theory');
map (thms_of o #2) (!theory');
val isacthms = (flat o (map (thms_of o #2))) (!theory');
(*takes a few seconds...
val rlsthmsNOTisac = gen_diff eq_thmI (isacrlsthms, isacthms);
length rlsthmsNOTisac;
"----- theorems from rulesets NOT def. in isac -----vvvvvvvvvvvvvv";
print_depth 99; map #1 rlsthmsNOTisac; print_depth 3;
"----- theorems from rulesets NOT def. in isac -----^^^^^^^^^^^^^^";
...*)

"----- for 'fun make_isab_thm_thy'";
gen_inter eq_thmI (isacrlsthms, (thms_of (nth 1 ancestors)));
gen_inter eq_thmI;
curry (gen_inter eq_thmI);
curry (gen_inter eq_thmI) isacrlsthms;
(*takes a few seconds...
curry (gen_inter eq_thmI) isacrlsthms (thms_of (nth 9 ancestors));

val thy = (nth 52 ancestors);
val sec = (curry (gen_inter eq_thmI) isacrlsthms o thms_of) (nth 52 ancestors);
length (thms_of (nth 9 ancestors));
length sec;
...*)

(*takes 1 minute...
print_depth 99; 
map (curry (gen_inter eq_thmI) rlsthmsNOTisac o thms_of) ancestors;
print_depth 3;
*)

(*takes some seconds...
val isab_thm_thy = (flat o (map (make_isab_thm_thy rlsthmsNOTisac)))
		       ((#ancestors o rep_theory) first_isac_thy);
print_depth 99; isab_thm_thy; print_depth 3;
*)


"----------- fun thy_containing_thm ------------------------------";
"----------- fun thy_containing_thm ------------------------------";
"----------- fun thy_containing_thm ------------------------------";
val (str, (thy', thy)) = ("real_diff_minus",("Root.thy", Root.thy));
if thy_contains_thm str ("XXX",thy) then ()
else raise error "rewtools.sml: NOT thy_contains_thm \
		 \(real_diff_minus,(Root.thy,.";
(rev (!theory'));
dropuntil (curry op= thy');
dropuntil ((curry op= thy') o (#1:theory' * theory -> theory'));
val startsearch = dropuntil ((curry op= thy') o 
			     (#1:theory' * theory -> theory')) 
			    (rev (!theory'));
if thy_containing_thm thy' str = ("IsacKnowledge", "Root.thy") then ()
else raise error "rewtools.sml: NOT thy_containin_thm \
		 \(real_diff_minus,(Root.thy,.";

"----- search the same theorem somewhere further below in the list";
if thy_contains_thm str ("XXX",Poly.thy) then ()
else raise error "rewtools.sml: NOT thy_contains_thm \
		 \(real_diff_minus,(Poly.thy,.";
if thy_containing_thm "LinEq.thy" str = ("IsacKnowledge", "Poly.thy") then ()
else raise error "rewtools.sml: NOT thy_containing_thm \
		 \(real_diff_minus,(Poly.thy,.";

"----- second test -------------------------------";
show_thes();
(*args vor thy_containing_thm...*)
val (thy',str) = ("Test.thy", "radd_commute");
val startsearch = dropuntil ((curry op= thy') o 
				     (#1:theory' * theory -> theory')) 
				    (rev (!theory'));
length (!theory');
length startsearch;
if thy_containing_thm thy' str = ("IsacKnowledge", "Test.thy") then ()
else raise error "rewtools.sml: diff.behav. in \
		 \thy_containing_thm Test radd_commute";


"----------- fun thy_containing_rls ------------------------------";
"----------- fun thy_containing_rls ------------------------------";
"----------- fun thy_containing_rls ------------------------------";
val thy' = "Biegelinie.thy";
val dropthys = takewhile [] (not o (curry op= thy') o 
			     (#1:theory' * theory -> theory')) 
			 (rev (!theory'));
if length (!theory') <> length dropthys then ()
else raise error "rewtools.sml: diff.behav. in thy_containing_rls 1";
val dropthy's = map (get_thy o (#1 : (theory' * theory) -> theory'))
		    dropthys;
print_depth 99; dropthy's; print_depth 3;

"Isac" mem dropthy's;
op mem ("Isac", dropthy's);
(op mem) o swap;
((op mem) o swap) (dropthy's, "Isac");
curry ((op mem) o swap);
curry ((op mem) o swap) dropthy's "Isac";
val startsearch = filter_out ((curry ((op mem) o swap) dropthy's) o	 
			      ((#1 o #2) : rls' * (theory' * rls) -> theory'))
			     (rev (!ruleset'));
print_depth 99; map (#1 o #2) startsearch; print_depth 3;
if length (!ruleset') <> length startsearch then ()
else raise error "rewtools.sml: diff.behav. in thy_containing_rls 2";

val rls' = "norm_Poly";
case assoc (startsearch, rls') of
    Some (thy', _) => thyID2theory' thy'
  | _ => raise error ("thy_containing_rls : rls '"^str^
			  "' not in !rulset' und thy '"^thy'^"'");

if thy_containing_rls thy' rls' = ("IsacKnowledge", "Poly.thy") then ()
else raise error "rewtools.sml: diff.behav. in thy_containing_rls 3";


"----------- fun thy_containing_cal ------------------------------";
"----------- fun thy_containing_cal ------------------------------";
"----------- fun thy_containing_cal ------------------------------";
val thy' = "Atools.thy";
val dropthys = takewhile [] (not o (curry op= thy') o 
			     (#1:theory' * theory -> theory')) 
			 (rev (!theory'));
length dropthys <> length (!theory');
val dropthy's = map (get_thy o (#1 : (theory' * theory) -> theory'))
		    dropthys;

(rev (!calclist'));
map #1 (rev (!calclist'));
map (#1 : calc -> string) (rev (!calclist'));
val startsearch = filter_out ((curry ((op mem) o swap) dropthy's) o
			      (#1 : calc -> string)) (rev (!calclist'));

"----------- initContext Thy_ Integration-demo -------------------";
"----------- initContext Thy_ Integration-demo -------------------";
"----------- initContext Thy_ Integration-demo -------------------";
states:=[];
CalcTree
[(["functionTerm (2 * x)","integrateBy x","antiDerivative FF"], 
  ("Integrate.thy",["integrate","function"],
  ["Diff","integration"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
interSteps 1 ([1],Res);
interSteps 1 ([1,1],Res);
val ((pt,p),_) = get_calc 1; show_pt pt;
if existpt' ([1,1,1], Frm) pt then ()
else raise error "integrate.sml: interSteps on Rewrite_Set_Inst 1";

initContext  1 Thy_ ([1,1,1], Frm);


"----------- initContext..Thy_, fun context_thm ------------------";
"----------- initContext..Thy_, fun context_thm ------------------";
"----------- initContext..Thy_, fun context_thm ------------------";
states:=[];
CalcTree      (*start of calculation, return No.1*)
[(["equality (x+1=2)", "solveFor x","solutions L"], 
  ("Test.thy", 
   ["sqroot-test","univariate","equation","test"],
   ["Test","squ-equ-test-subpbl1"]))];
Iterator 1; moveActiveRoot 1;
autoCalculate 1 CompleteCalc;

"----- no thy-context at result -----";
val p = ([], Res);
initContext 1 Thy_ p;


interSteps 1 ([2], Res);
interSteps 1 ([3,1], Res);
val ((pt,_),_) = get_calc 1; show_pt pt;

val p = ([2,4], Res);
val tac = Rewrite ("radd_left_commute","");
initContext 1 Thy_ p;
(*Res->Res, Rewrite "radd_left_commute 1 + (-2 + x) = 0 -> -2 + (1 + x) = 0
  --- in initContext..Thy_ ---*)
val ContThm {thm,result,...} = context_thy (pt,p) tac;
if thm = "thy_isac_Test-thm-radd_left_commute" 
   andalso term2str result = "-2 + (1 + x) = 0" then ()
else raise error"rewtools.sml initContext..Th_ thy_Test-thm-radd_left_commute";

val p = ([3,1,1], Frm);
val tac = Rewrite_Inst (["(bdv, x)"],("risolate_bdv_add",""));
initContext 1 Thy_ p;
(*Frm->Res, Rewrite_Inst "risolate_bdv_add"  -1 + x = 0 -> x = 0 + -1 * -1
  --- in initContext..Thy_ ---*)
val ContThmInst {thm,result,...} = context_thy (pt,p) tac;
if thm =  "thy_isac_Test-thm-risolate_bdv_add"
   andalso term2str result = "x = 0 + -1 * -1" then ()
else raise error "rewtools.sml initContext..Th_ thy_Test-thm-risolate_bdv_add";

initContext 1 Thy_ ([2,5], Res);
(*Res->Res, Calculate "plus"  -2 + (1 + x) = 0 -> -1 + x = 0
  --- in initContext..Thy_ ---*)


"----------- initContext..Thy_, fun context_rls ------------------";
"----------- initContext..Thy_, fun context_rls ------------------";
"----------- initContext..Thy_, fun context_rls ------------------";
(*using pt from above*)
val p = ([1], Res);
val tac = Rewrite_Set "Test_simplify";
initContext 1 Thy_ p;
(*Res->Res, Rewrite_Set "Test_simplify" x + 1 + -1 * 2 = 0 -> -1 + x = 0
  --- in initContext..Thy_ ---*)
val ContRls {rls,result,...} = context_thy (pt,p) tac;
if rls = "thy_isac_Test-rls-Test_simplify" 
   andalso term2str result = "-1 + x = 0" then ()
else raise error "rewtools.sml initContext..Th_ thy_Test-thm-risolate_bdv_add";

val p = ([3,1], Frm);
val tac = Rewrite_Set_Inst (["(bdv, x)"],"isolate_bdv");
initContext 1 Thy_ p;
(*Frm->Res, Rewrite_Set_Inst "isolate_bdv" -1 + x = 0 ->  x = 0 + -1 * -1
  --- in initContext..Thy_ ---*)
val ContRlsInst {rls,result,...} = context_thy (pt,p) tac;
if rls =  "thy_isac_Test-rls-isolate_bdv"
   andalso term2str result = "x = 0 + -1 * -1" then ()
else raise error "rewtools.sml initContext..Th_ thy_Test-thm-risolate_bdv_add";



"----------- checkContext..Thy_, fun context_thy -----------------";
"----------- checkContext..Thy_, fun context_thy -----------------";
"----------- checkContext..Thy_, fun context_thy -----------------";
(*using pt from above*)

val p = ([2,4], Res);
val tac = Rewrite ("radd_left_commute","");
checkContext 1 p "thy_Test-thm-radd_left_commute";
(* radd_left_commute: 1 + (-2 + x) = 0 -> -2 + (1 + x) = 0
  --- in checkContext..Thy_ ---*)
val ContThm {thm,result,...} = context_thy (pt,p) tac;
if thm =  "thy_isac_Test-thm-radd_left_commute"
   andalso term2str result = "-2 + (1 + x) = 0" then ()
else raise error "rewtools.sml checkContext.._ thy_Test-thm-radd_left_commute";

val p = ([3,1,1], Frm);
val tac = Rewrite_Inst (["(bdv,x)"],("risolate_bdv_add",""));
checkContext 1 p "thy_Test-thm-risolate_bdv_add";
(* risolate_bdv_add:  -1 + x = 0 -> x = 0 + -1 * -1
  --- in checkContext..Thy_ ---*)
val ContThmInst {thm,result,...} = context_thy (pt,p) tac;
if thm =  "thy_isac_Test-thm-risolate_bdv_add"
   andalso term2str result = "x = 0 + -1 * -1" then ()
else raise error "rewtools.sml checkContext..T_ thy_Test-thm-risolate_bdv_add";

val p = ([2,5], Res);
val tac = Calculate "plus";
(*checkContext..Thy_ 1 ([2,5], Res);*)
(*FIXXXME #######################vvvvv kestoreID !!!!!!!!!!!!!!!!*)
checkContext 1 p ;
(* Calculate "plus"  -2 + (1 + x) = 0 -> -1 + x = 0
  --- in checkContext..Thy_ ---*)


"----------- checkContext..Thy_, fun context_rls -----------------";
"----------- checkContext..Thy_, fun context_rls -----------------";
"----------- checkContext..Thy_, fun context_rls -----------------";
(*using pt from above*)
show_pt pt;

val p = ([1], Res);
val tac = Rewrite_Set "Test_simplify";
checkContext 1 p "thy_isac_Test-rls-Test_simplify";
(*Res->Res, Rewrite_Set "Test_simplify" x + 1 + -1 * 2 = 0 -> -1 + x = 0
  --- in checkContext..Thy_ ---*)
val ContRls {rls,result,...} = context_thy (pt,p) tac;
if rls = "thy_isac_Test-rls-Test_simplify" 
   andalso term2str result = "-1 + x = 0" then ()
else raise error "rewtools.sml checkContext..Thy_ thy_Test-rls-Test_simplify";

val p = ([3,1], Frm);
val tac = Rewrite_Set_Inst (["(bdv, x)"],"isolate_bdv");
checkContext 1 p "thy_Test-rls-isolate_bdv";
val ContRlsInst {rls,result,...} = context_thy (pt,p) tac;
if rls = "thy_isac_Test-rls-isolate_bdv" 
   andalso term2str result = "x = 0 + -1 * -1" then ()
else raise error "rewtools.sml checkContext..Thy_ thy_Test-thm-isolate_bdv";


"----------- checkContext..Thy_ on last formula ------------------"; 
"----------- checkContext..Thy_ on last formula ------------------"; 
"----------- checkContext..Thy_ on last formula ------------------"; 
states:=[];
CalcTree      (*start of calculation, return No.1*)
[(["equality (x+1=2)", "solveFor x","solutions L"], 
  ("Test.thy", 
   ["sqroot-test","univariate","equation","test"],
   ["Test","squ-equ-test-subpbl1"]))];
Iterator 1; moveActiveRoot 1;

autoCalculate 1 CompleteCalcHead;
autoCalculate 1 (Step 1);
val (ptp as (pt,p), tacis) = get_calc 1; show_pt pt;
initContext 1 Thy_ ([1], Frm);
checkContext 1 ([1], Frm) "thy_isac_Test-thm-radd_left_commute";

autoCalculate 1 (Step 1);
val (ptp as (pt,p), tacis) = get_calc 1; show_pt pt;
initContext 1 Thy_ ([1], Res);
checkContext 1 ([1], Res) "thy_isac_Test-rls-Test_simplify";



"----------- fun guh2theID ---------------------------------------";
"----------- fun guh2theID ---------------------------------------";
"----------- fun guh2theID ---------------------------------------";
val guh = "thy_scri_ListG-thm-zip_Nil";

take_fromto 1 4 (explode guh);
take_fromto 5 9 (explode guh);
val rest = takerest (9,(explode guh)); 

separate "-" rest;
space_implode "-" rest;
commas rest;

val delim = "-";
val thyID = takewhile [] (not o (curry op= delim)) rest;
val rest' = dropuntil (curry op= delim) rest;
val setc = take_fromto 1 5 rest';
val xstr = takerest (5, rest');

if guh2theID guh = ["IsacScripts", "ListG", "Theorems", "zip_Nil"] then ()
else raise error "rewtools.sml: guh2theID thy_scri_ListG-thm-zip_Nil changed";


"----------- debugging on Tests/solve_linear_as_rootpbl ----------";
"----------- debugging on Tests/solve_linear_as_rootpbl ----------";
"----------- debugging on Tests/solve_linear_as_rootpbl ----------";
"----- initContext -----";
states:=[];
CalcTree 
    [(["equality (1+-1*2+x=0)", "solveFor x", "solutions L"],
      ("Test.thy",
       ["linear","univariate","equation","test"],
       ["Test","solve_linear"]))];
Iterator 1; moveActiveRoot 1;
autoCalculate 1 CompleteCalcHead;

autoCalculate 1 (Step 1); val (ptp as (pt,p), tacis) = get_calc 1; show_pt pt;
if is_curr_endof_calc pt ([1],Frm) then ()
else raise error "rewtools.sml is_curr_endof_calc ([1],Frm)";

autoCalculate 1 (Step 1); val (ptp as (pt,p), tacis) = get_calc 1; show_pt pt;
if not (is_curr_endof_calc pt ([1],Frm)) then ()
else raise error "rewtools.sml is_curr_endof_calc ([1],Frm) not";
if is_curr_endof_calc pt ([1],Res) then ()
else raise error "rewtools.sml is_curr_endof_calc ([1],Res)";

initContext 1 Thy_ ([1],Res);

"----- checkContext -----";
states:=[];
CalcTree 
    [(["equality (1+-1*2+x=0)", "solveFor x", "solutions L"],
      ("Test.thy",
       ["linear","univariate","equation","test"],
       ["Test","solve_linear"]))];
Iterator 1; moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
interSteps 1 ([1],Res);
val (ptp as (pt,p), tacis) = get_calc 1; show_pt pt;

checkContext 1 ([1],Res) "thy_isac_Test-rls-Test_simplify";

interSteps 1 ([2],Res);
val (ptp as (pt,p), tacis) = get_calc 1; show_pt pt;

checkContext 1 ([2,1],Res) "thy_isac_Test-rls-Test_simplify";
checkContext 1 ([2,2],Res) "thy_isac_Test-rls-Test_simplify";


